#- - - - - - - - - - - -#
# Analyse exploratoire  #
#- - - - - - - - - - - -#


isna<-function(vec,caract="quantitatif")
{
if (caract=="quantitatif")
	{
	sumna<-sum(is.na(as.numeric(vec)))
	return(sumna)
	}
if (caract=="qualitatif")
	{
	inc<-substr(as.character(vec),2,4)=="inc"
	sumna<-sum(inc)
	return(sumna)
	}
}

ana.uni.quanti<-function(var,table=visprem,
	range = 1.5, width = NULL, varwidth = FALSE,           # --------------------------------
	notch = FALSE, outline = TRUE, border = par("fg"),     # arguments de la fonction boxplot
        col = "red", pars = NULL, horizontal = TRUE,           # --------------------------------        
        breaks2 = "Sturges",col2 = "red", border2 = NULL,      # --------------------------------
        main2 = paste("Histogramme de la variable" , var),     # arguments de la fonction hist
        axes2=TRUE)                                            # -------------------------------- 
{
vec<-table[,var]
vm<-isna(vec)
if (vm!= 0) 
   {
   print("___________________________________________",quote = FALSE)
   print(paste("Il y'a",vm,"valeur(s) manquante(s)"))
   }
print("___________________________________________",quote = FALSE)
print(paste("Distribution de la variable",var))
print(summary(vec))
print("___________________________________________",quote = FALSE)

x11()
boxplot(vec,
	range = range, width = width, varwidth = varwidth,
        notch = notch, outline = outline, border = border,
        col = col, pars = pars, horizontal = horizontal, boxwex = 0.3)
title(paste("Distribution de la variable",var))
x11()
hist(vec,breaks = breaks2,col = col2, border = border2,
     main=main2,axes=axes2)
}


ana.uni.quali<-function(var,table=visprem,na=TRUE,edges = 200, radius = 0.8,
	  	       density = NULL, angle = 45,main = NULL)
{
vec<-table[,var]
dist<-summary(vec)
vm<-isna(vec,caract="qualitatif")
if (vm!= 0) 
   {
   print("___________________________________________",quote = FALSE)
   print(paste("Il y'a",vm,"valeur(s) manquante(s)"))
   }
print("___________________________________________",quote = FALSE)
print(paste("Distribution de la variable",var))
print(dist)
print("___________________________________________",quote = FALSE)

if (na=="FALSE")
   {  
   repart<-dist[substr(attributes(dist)$names,2,4)!="inc"]
   }
if (na=="TRUE")
   {
   repart<-dist
   }

prop<-round(100*repart/sum(repart),2)
leg<-rep(0,length(repart))
for (i in 1:length(repart))
	{
	leg[i]<-paste(attributes(repart)$names[i]," (",prop[i]," %)",sep="")
	}
x11()	
pie(repart, labels =leg, edges = edges, radius = radius,
   density = density, angle = angle, col =rainbow(length(repart)),main = main)
title(paste("Distribution de la variable",var))   
      
}



ana.bi.quanti<-function(var1,var2,table=visprem,
		       var3="CARVP",mod="Coui",col="red",type="p",xlab=var1, ylab=var2,ident=F)
{

don<-table[,c(var1,var2)]

vm<-sum(is.na(don[,1]*don[,2]))
if (vm!= 0) 
   {
   print("___________________________________________________",quote = FALSE)
   print(paste(vm,"couple(s) d'observations est(sont) incomplet(s)"))
   } 
   
cor<-cor(don[,var1],don[,var2],use="pairwise.complete.obs")
print("_____________________________________________________________________",quote = FALSE)
print(paste("Le coefficient de corrlation entre les variables",var1,"et",var2,"est :"),quote=FALSE)
print(cor)
print("_____________________________________________________________________",quote = FALSE) 

don1<-subset(don,table[,var3]==mod)
don2<-subset(don,table[,var3]!=mod)
x11()
plot(don1[,var1],don1[,var2], xlim=range(don[,1]), ylim=range(don[,2]), type=type,
     xlab=xlab, ylab=ylab)
points(don2[,var1],don2[,var2],col=col)
title(paste("Nuage de points des variables",var1,"et",var2))
if (ident) identify(rbind(don1,don2),labels=row.names(rbind(don1,don2)),plot=T)

}



ana.bi.quali<-function(var1,var2,table=visprem,ident=F)
{
vec1<-table[,var1]
vec2<-table[,var2]
nlev1<-length(attributes(vec1)$levels)
nlev2<-length(attributes(vec2)$levels)

conting<-matrix(0,nlev1,nlev2)
cont<-by(vec1,vec2,summary)
for (i in 1:nlev2)
	{
	conting[,i]<-cont[[i]]
	}
nomi<-attributes(vec1)$levels
nomj<-attributes(vec2)$levels
dimnames(conting)<-list(nomi,nomj)

print("________________________________________________",quote = FALSE)
print(paste("Table de contingence",var1,"x",var2,"(en effectif)") ,quote = FALSE)
print(conting)
print("________________________________________________",quote = FALSE)

contingp<-contingp<-round(100*conting/sum(conting),2)
print("____________________________________________________________",quote = FALSE)
print(paste("Table de contingence",var1,"x",var2,"(en pourcentage du total)") ,quote = FALSE)
print(contingp)
print("____________________________________________________________",quote = FALSE)

x11()
barplot(contingp, beside = TRUE,col = rainbow(nlev1),legend = rownames(contingp), ylim = c(0, max(50,max(contingp)+5)))
title(paste("Diagramme en barres croises des variables",var1,"et",var2,"\n(en pourcentage)"))

}



ana.bi.mixte<-function(var,varcl,table=visprem,
                      range = 1.5, width = NULL, varwidth = FALSE,
	              notch = FALSE, outline = TRUE, border = par("fg"),
                      col = NULL, pars = NULL, horizontal = FALSE)
{
vec1<-table[,var]
vec2<-table[,varcl]
nlev<-length(attributes(vec2)$levels)

distcomp0<-by(vec1,vec2,summary)
d1<-distcomp0[[1]]
d2<-distcomp0[[2]]
distcomp<-as.matrix(rbind(d1,d2))
dimnames(distcomp)[[1]][1]<-attributes(vec2)$levels[[1]]
dimnames(distcomp)[[1]][2]<-attributes(vec2)$levels[[2]]

print("____________________________________________________________________________",quote = FALSE)
print(paste("Distribution de la variable",var,"selon les modalits de la variable",varcl),quote = FALSE) 
print(distcomp)
print("____________________________________________________________________________",quote = FALSE)
x11()
boxplot(vec1~vec2,
	range = range, width = width, varwidth = varwidth,
        notch = notch, outline = outline, border = border,
        col = col, pars = pars, horizontal = horizontal, boxwex = 0.3)
title(paste("Distribution de la variable",var,"\nselon les modalits de la variable",varcl))

}


#- - - - - - - - - - - -#
# Analyse discriminante #
#- - - - - - - - - - - -#

plot.knn<-function(train,vcl, kmax = 5, CV=FALSE, test=NULL, l = 0, prob = FALSE, use.all = TRUE)
{

cl<-train[,vcl]                                 # Var. de Cl. dans l'ech. d'apprentissage
cltest<-test[,vcl]                              # Var. de Cl. dans l'ech. de test
train<-train[,names(train)[names(train)!=vcl]]  # ech. d'apprentissage
test<-test[,names(test)[names(test)!=vcl]]      # ech. de test


nk<-1:kmax                                      
mc<-rep(1,kmax)
for (i in 1:kmax)
   {
   res.knn<-if (CV) {knn.cv(train, cl, k = i)} else 
                   {knn(train,test,cl,k=i)}                  # Classification
   mcl<-if (CV) {mean(1-as.numeric(res.knn==cl))}  else 
               {mean(1-as.numeric(res.knn==cltest))}         # Calcul du taux de m.c.
   if (mcl<min(mc)) {kopt<-i; mcmin<-mcl}                      # Calcul du k opt et du 
   mc[i]<-mcl                                                 # taux de m.c. correspondant
}

print("________________________________________________________________________",quote=F)
print("                                    ",quote=F)
print("Taux de mal classs :",quote=F)
print(paste("k=",nk," : ",100*round(mc,6),"%; ", sep=""),quote=F)
print("________________________________________________________________________",quote=F)
print("                                    ",quote=F)
print("____________________________________",quote=F)
print("                                    ",quote=F)
print(paste("k optimal : ",kopt, sep=""),quote=F)
print(paste("Taux de mal classs pour k=",kopt," : ",100*round(mcmin,4),"%", sep=""),quote=F)
print("____________________________________",quote=F)

plot(nk,mc,type="l",main="Taux de mal classs",xlab="k",ylab="",ylim=c(0,1),col="blue")
lines(c(kopt,kopt),c(-0.1,mcmin),col="red")

}


#- - - - - - - - - - - -#
# Rgression logistique #
#- - - - - - - - - - - -#

CVlog<-function(formula, data,nplis = 10) 
{ 
n = nrow(data) 
tmc <- 0 
un <- rep(1, n) 
ri <- sample(nplis, n, replace = TRUE) 
cat(" pli") 
for(i in sort(unique(ri))) { 
cat(" ", i, sep = "") 
resmod<-glm(formula=formula,data=data[ri!=i,],family=binomial,na.action=na.omit) 
tmc = tmc + sum(un[(data$CARVP[ri == i] == "Coui") != 
(predict(resmod, data[ri == i, ]) > 0.5)]) } 
cat("\n", "Taux de mal class\351s") 
tmc/(length(unique(ri)) * n) 
} 


#- - - - - - - - - - - -#
#  Rseaux de neurones  #
#- - - - - - - - - - - -#


CVnn<-function(formula, data, size, niter = 1, nplis = 10, decay = 0, maxit = 100) 
{ 
n = nrow(data) 
tmc <- 0 
un <- rep(1, n) 
ri <- sample(nplis, n, replace = T) 
cat(" pli") 
for(i in sort(unique(ri))) { 
cat(" ", i, sep = "") 
for(rep in 1:niter) { 
learn <- nnet(formula, data[ri != i, ], size = size, 
trace = F, decay = decay, maxit = maxit) 
tmc = tmc + sum(un[(data$CARVP[ri == i] == "Coui") != 
(predict(learn, data[ri == i, ]) > 0.5)]) 
} 
} 
cat("\n", "Taux de mal classes") 
tmc/(niter * length(unique(ri)) * n) 
} 